<template>
  <div class="transfer-config-mode">
    <BasicForm :showSubmitButton="false" @register="register" />
  </div>
</template>
<script lang="ts">
  import { defineComponent, reactive, nextTick } from 'vue';
  import { BasicForm, useForm } from '/@/components/Form';
  import { modeRabbitMqForm } from '../config';

  export default defineComponent({
    components: {
      BasicForm,
    },
    emits: ['next', 'prev', 'register'],
    setup(_, { emit }) {
      const sonValues = reactive({
        configuration: {},
      });

      const [register, { validate, setFieldsValue, resetFields: defineClearFunc }] = useForm({
        labelWidth: 140,
        schemas: modeRabbitMqForm,
        actionColOptions: {
          span: 14,
        },
        resetButtonOptions: {
          text: '上一步',
        },

        resetFunc: customResetFunc,
        submitFunc: customSubmitFunc,
      });

      const setStepTwoFieldsValueFunc = (v, v1, v2) => {
        setFieldsValue(v);
        setFieldsValue({
          name: v1,
          description: v2,
        });
      };
      const customClearStepTwoValueFunc = async () => {
        nextTick(() => {
          defineClearFunc();
        });
      };
      async function customResetFunc() {
        emit('prev');
      }
      async function customSubmitFunc() {
        try {
          const values = await validate();
          emit('next', values);
        } catch (error) {
        } finally {
        }
      }

      const getSonValueFunc = async () => {
        sonValues.configuration = await validate();
        Object.assign(sonValues.configuration);
        return sonValues;
      };

      return {
        getSonValueFunc,
        register,
        setStepTwoFieldsValueFunc,
        customClearStepTwoValueFunc,
      };
    },
  });
</script>
<style lang="less" scoped>
  :deep(.ant-btn-default) {
    color: white;
    background: #377dff;
  }
</style>
